Attribute VB_Name = "modAPI32"
Option Base 0
Option Explicit

Public Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Public Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Public Declare Function EnumResourceTypes Lib "kernel32" Alias "EnumResourceTypesA" (ByVal hModule As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Public Declare Function EnumResourceNames Lib "kernel32" Alias "EnumResourceNamesA" (ByVal hModule As Long, ByVal lpType As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long

Public Declare Function LockResource Lib "kernel32" (ByVal hResData As Long) As Long
Public Declare Function FindResource Lib "kernel32" Alias "FindResourceA" (ByVal hInstance As Long, ByVal lpName As Long, ByVal lpType As Long) As Long
Public Declare Function LoadResource Lib "kernel32" (ByVal hInstance As Long, ByVal hResInfo As Long) As Long

Global Const RT_CURSOR = 1
Public Const RT_BITMAP = 2
Public Const RT_ICON = 3
Public Const RT_MENU = 4
Public Const RT_DIALOG = 5
Public Const RT_STRING = 6
Public Const RT_FONTDIR = 7
Public Const RT_FONT = (8)
Public Const RT_ACCELERATOR = 9
Public Const RT_RCDATA = 10
Public Const RT_MESSAGETABLE = 11
Public Const DIFFERENCE = 11
Public Const RT_GROUP_CURSOR = RT_CURSOR + DIFFERENCE
Public Const RT_GROUP_ICON = RT_ICON + DIFFERENCE
Public Const RT_VERSION = 16
Public Const RT_DLGINCLUDE = 17
Public Const RT_PLUGPLAY = 19
Public Const RT_VXD = 20
Public Const RT_ANICURSOR = 21
Public Const RT_ANIICON = 22

Public Declare Function CreateIconFromResource Lib "user32" (ByVal presbits As Long, ByVal dwResSize As Long, ByVal fIcon As Long, ByVal dwVer As Long) As Long
Public Declare Function SizeofResource Lib "kernel32" (ByVal hInstance As Long, ByVal hResInfo As Long) As Long

Public Type BITMAPINFOHEADER
        biSize As Long
        biWidth As Long
        biHeight As Long
        biPlanes As Integer
        biBitCount As Integer
        biCompression As Long
        biSizeImage As Long
        biXPelsPerMeter As Long
        biYPelsPerMeter As Long
        biClrUsed As Long
        biClrImportant As Long
End Type
Public Type RGBQUAD
        rgbBlue As Byte
        rgbGreen As Byte
        rgbRed As Byte
        rgbReserved As Byte
End Type
Public Type BITMAPINFO
        bmiHeader As BITMAPINFOHEADER
        bmiColors As RGBQUAD
End Type


Public Const MAX_PATH = 260&

Public Const INVALID_HANDLE_VALUE = -1

Public Const FILE_ATTRIBUTE_NORMAL = &H80
Public Const GENERIC_WRITE = &H40000000
Public Const CREATE_ALWAYS = 2

Public Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Public Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, ByRef lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, ByRef lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long

Declare Function GetLastError Lib "kernel32" () As Long


Public Type SHITEMID 'mkid
    cb As Long
    abID As Byte
End Type

Public Type ITEMIDLIST  'idl
    mkid As SHITEMID
End Type

Public Type BROWSEINFO  'bi
    hOwner As Long
    pidlRoot As Long
    pszDisplayName As String
    lpszTitle As String
    ulFlags As Long
    lpfn As Long
    lParam As Long
    iImage As Long
End Type
        

Public Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Public Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long

Public Const BIF_RETURNONLYFSDIRS = &H1
Public Const BIF_STATUSTEXT = &H4

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Long) As Long
Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Const CB_SHOWDROPDOWN = &H14F
Public Const CB_GETDROPPEDSTATE = &H157
Public Const LB_SETTABSTOPS = &H192
Public Const LB_SETHORIZONTALEXTENT = &H194

Public Declare Function GetDialogBaseUnits Lib "user32" () As Long


Public Sub AddTabInList(frm As Object, lb As Control, ParamArray rtbTabStops() As Variant)
    Dim lfnt        As Font
    Dim i           As Integer
    Dim l           As Long
    Dim lpnTabs()   As Long
    Dim cTabs       As Integer
    
'    baseunitX = GetDialogBaseUnits() And &HFFFF&
'    pixelX = (dialogunitX * baseunitX) / 4
    cTabs = UBound(rtbTabStops) - LBound(rtbTabStops) + 1
    ReDim lpnTabs(cTabs)
    For i = LBound(rtbTabStops) To UBound(rtbTabStops)
        lpnTabs(i - LBound(rtbTabStops)) = rtbTabStops(i)
    Next
  
    'Enregistre les proprits de la feuille
    Set lfnt = frm.Font

    ' Set the list box's container's properties
    ' so that the TextWidth method of the form
    ' gives accurate results.
    Set frm.Font = lb.Font
       
    
    'Active les "tab stops" dans la listbox
    l = SendMessage(lb.hWnd, LB_SETTABSTOPS, cTabs, lpnTabs(0))
  
    ' Set the horizontal extent to the last tab stop.
    ' Because the tab-stop array holds dialog box units (which represent
    ' 4 times the number of characters), to get that value converted
    ' into pixels, perform the inverse operation.
    'liRet = SendMessage(lb.hwnd, LB_SETHORIZONTALEXTENT, (TabStops(3) \ 4) * AvgCharWidth, 0&)
  
    'Actualise l'affichage
    lb.Refresh
  
    'Recharge les proprits initiales de la feuille
    Set frm.Font = lfnt
End Sub

